#include "serial.h"

serial::serial(const string& dev,int flags)
{
  fd = open(dev.c_str(),flags);
  fcntl(fd, F_SETFL, 0);
  struct termios options;
  tcgetattr(fd, &options);
  cfsetispeed(&options, B9600);
  cfsetospeed(&options, B9600);
  options.c_cflag |= (CLOCAL | CREAD);
  options.c_cflag &= ~PARENB;
  options.c_cflag &= ~CSTOPB;
  options.c_cflag &= ~CSIZE;
  options.c_cflag |= CS8;
  tcsetattr(fd, TCSANOW, &options);
}

serial::~serial()
{
  close(fd);
}

int serial::writeport(char *chars) {
        int len = strlen(chars);
        chars[len] = 0x0d; // stick a <CR> after the command
        chars[len+1] = 0x00; // terminate the string properly
        int n = write(fd, chars, strlen(chars));
        if (n < 0) {
                fputs("write failed!\n", stderr);
                return 0;
        }
        return 1;
}

int serial::readport(char *result) 
{
  int iIn = read(fd, result, 254);
  result[iIn-1] = 0x00;
  if (iIn < 0) 
  {
    return 0;
  }
    return 1;
}

int serial::getbaud() {
        struct termios termAttr;
        int inputSpeed = -1;
        speed_t baudRate;
        tcgetattr(fd, &termAttr);
        /* Get the input speed.                              */
        baudRate = cfgetispeed(&termAttr);
        switch (baudRate) {
                case B0:      inputSpeed = 0; break;
                case B50:     inputSpeed = 50; break;
                case B110:    inputSpeed = 110; break;
                case B134:    inputSpeed = 134; break;
                case B150:    inputSpeed = 150; break;
                case B200:    inputSpeed = 200; break;
                case B300:    inputSpeed = 300; break;
                case B600:    inputSpeed = 600; break;
                case B1200:   inputSpeed = 1200; break;
                case B1800:   inputSpeed = 1800; break;
                case B2400:   inputSpeed = 2400; break;
                case B4800:   inputSpeed = 4800; break;
                case B9600:   inputSpeed = 9600; break;
                case B19200:  inputSpeed = 19200; break;
                case B38400:  inputSpeed = 38400; break;
        }
        return inputSpeed;
}

