#include "xbeejslistener.h"


xbeejslistener::xbeejslistener(const string& dev, int flags) : 
  xbee(dev, flags)
{ 
  prevleft = 0;
  prevright = 0;
}

void xbeejslistener::actionPerformed(void* event,void* actor)
{
  js_event *js  = (js_event *)event;
  joystick *stick = (joystick *)actor;
  int servo;
  char srvstr[40];
  
  if( (JS_EVENT_AXIS == (js->type & ~JS_EVENT_INIT)) 
      && 1 == js->number
    )
  {
     servo = ( (float) ( -(js->value) * .0152592547 ) + 1500) ;
     if(servo != prevleft)
     {
       strcpy(srvstr, "srvleft =     ");
       srvstr[11] = (char)(servo/1000+'0');
       srvstr[12] = (char)((servo % 1000)/100+'0');
       srvstr[13] = (char)((servo % 100)/10+'0');
       srvstr[14] = (char)(servo % 10 + '0');
       srvstr[15] = (char)0;
       srvstr[16] = (char)0;
       if(!writeport(srvstr))
       {
         //TODO: error code here
       }
       else
       {
         prevleft = servo;
       }
     }
  }
  else if( (JS_EVENT_AXIS == (js->type & ~JS_EVENT_INIT)) 
           && 3 == js->number
         )
  {
     servo = ( (float) ( (js->value) * .0152592547 ) + 1500) ;
     if(servo != prevright)
     {
       strcpy(srvstr, "srvright =     ");
       srvstr[12] = (char)(servo/1000+'0');
       srvstr[13] = (char)((servo % 1000)/100+'0');
       srvstr[14] = (char)((servo % 100)/10+'0');
       srvstr[15] = (char)(servo % 10 + '0');
       srvstr[16] = (char)0;
       srvstr[17] = (char)0;
       if(!writeport(srvstr))
       {
         //TODO: error code here
       }
       else
       {
         prevright = servo;
       }
     }    
  }
  else if( (JS_EVENT_BUTTON == (js->type & ~JS_EVENT_INIT)) 
           && 9 == js->number
           && 1 == js->value
         )
  {

  }
}

int xbeejslistener::writeport(char *chars)
{
  return xbee.writeport(chars);
}

int xbeejslistener::readport(char *result)
{
  return xbee.writeport(result);
}

int xbeejslistener::getbaud()
{
  return xbee.getbaud();
}
